# STM32H7B3I-EVAL Evaluation board

## Overview

The STM32H7B3I-EVAL Evaluation board is a complete demonstration and development platform for the Arm® Cortex®-M7-based STM32H7B3LIH6QU microcontroller. The STM32H7B3I-EVAL Evaluation board provides access to all the STM32 peripherals for user applications, and include an embedded STLINK-V3E debugger/programmer.

The full range of the STM32H7B3I-EVAL hardware features helps to develop applications and evaluate all the peripherals, such as USB OTG_HS and FS, CAN FD, USART, ADC and DAC, digital microphones, SRAM, SDRAM, NOR Flash memory, Octo-SPI Flash memory with OTFDEC, microSD™ 3.0 card, 7" 800x480 WVGA TFT color RGB LCD with capacitive touch panel (I2C), and DCMI camera.

The expansion connectors provide an easy way to add specialized features, while ETM trace is supported through external probes.

## Getting started

- [User manual](https://www.st.com/resource/en/user_manual/um2662-evaluation-board-with-stm32h7b3li-mcu-stmicroelectronics.pdf)

### ST-LINK driver installation and firmware upgrade (on Microsoft Windows)

1. Download the latest [ST-LINK driver](https://www.st.com/en/development-tools/stsw-link009.html).
2. Extract the archive and run `dpinst_amd64.exe`. Follow the displayed instructions.
3. Download the latest [ST-LINK firmware upgrade](https://www.st.com/en/development-tools/stsw-link007.html).
4. Extract the archive and run the `ST-LinkUpgrade.exe` program.
5. Connect the board to your PC using a USB cable and wait until the USB enumeration is completed.
6. In the **ST-Link Upgrade** program, press the **Device Connect** button.
7. When the ST-LINK driver is correctly installed, the current ST-LINK version is displayed.
8. Press the **Yes >>>>** button to start the firmware upgrade process.

## Technical reference

- [STM32H7B3LI microcontroller](https://www.st.com/en/microcontrollers-microprocessors/stm32h7b3li.html)
- [STM32H7B3I-EVAL board](https://www.st.com/en/evaluation-tools/stm32h7b3i-eval.html)
- [User manual](https://www.st.com/resource/en/user_manual/um2662-evaluation-board-with-stm32h7b3li-mcu-stmicroelectronics.pdf)
- [Data brief](https://www.st.com/resource/en/data_brief/stm32h7b3i-eval.pdf)
- [Schematic](https://www.st.com/resource/en/schematic_pack/mb1331-h7b3liq-d03_schematic.pdf)
